#ifndef __X10_COMPILER_ABORT_H
#define __X10_COMPILER_ABORT_H

#include <x10rt.h>


#define X10_LANG_THROWABLE_H_NODEPS
#include <x10/lang/Throwable.h>
#undef X10_LANG_THROWABLE_H_NODEPS
namespace x10 { namespace compiler { 

class Abort : public x10::lang::Throwable   {
    public:
    RTT_H_DECLS_CLASS
    
    static x10aux::ref<x10::compiler::Abort> FMGL(ABORT);
    
    static void FMGL(ABORT__do_init)();
    static void FMGL(ABORT__init)();
    static volatile x10aux::status FMGL(ABORT__status);
    static x10aux::ref<x10::compiler::Abort> FMGL(ABORT__get)();
    static x10aux::ref<x10::lang::Reference> FMGL(ABORT__deserialize)(x10aux::deserialization_buffer &buf);
    static const x10aux::serialization_id_t FMGL(ABORT__id);
    
    void _constructor();
    
    static x10aux::ref<x10::compiler::Abort> _make();
    
    virtual x10aux::ref<x10::compiler::Abort> x10__compiler__Abort____x10__compiler__Abort__this(
      );
    
    // Serialization
    public: static const x10aux::serialization_id_t _serialization_id;
    
    public: virtual x10aux::serialization_id_t _get_serialization_id() {
         return _serialization_id;
    }
    
    public: virtual void _serialize_body(x10aux::serialization_buffer& buf);
    
    public: static x10aux::ref<x10::lang::Reference> _deserializer(x10aux::deserialization_buffer& buf);
    
    public: void _deserialize_body(x10aux::deserialization_buffer& buf);
    
};

} } 
#endif // X10_COMPILER_ABORT_H

namespace x10 { namespace compiler { 
class Abort;
} } 

#ifndef X10_COMPILER_ABORT_H_NODEPS
#define X10_COMPILER_ABORT_H_NODEPS
#include <x10/lang/Throwable.h>
#ifndef X10_COMPILER_ABORT_H_GENERICS
#define X10_COMPILER_ABORT_H_GENERICS
inline x10aux::ref<x10::compiler::Abort> x10::compiler::Abort::FMGL(ABORT__get)() {
    if (FMGL(ABORT__status) != x10aux::INITIALIZED) {
        FMGL(ABORT__init)();
    }
    return x10::compiler::Abort::FMGL(ABORT);
}

#endif // X10_COMPILER_ABORT_H_GENERICS
#endif // __X10_COMPILER_ABORT_H_NODEPS
